local L = LibStub("AceLocale-3.0"):GetLocale("Elephant")
local Elephant = LibStub("AceAddon-3.0"):GetAddon("Elephant")

function Elephant:ChangeLog(index)
	Elephant.dbpc.char.currentlogindex = index
	Elephant.tempConf.currentline = #Elephant.dbpc.char.logs[index].logs
	Elephant:ShowCurrentLog()
end

function Elephant:ShowCurrentLog()	
	Elephant.gui.scrollingMessageFrame:Clear()
	
	Elephant:SetObjectColorWithCurrentLogColor(Elephant.gui.titleInfoTab)
	Elephant:SetObjectColorWithCurrentLogColor(Elephant.gui.titleInfoCurrentLine)
	Elephant:SetObjectColorWithCurrentLogColor(Elephant.gui.scrollingMessageFrame)
	Elephant.gui.titleInfoTab:SetText("< " .. Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].name .. " >")
	Elephant:SetTitleInfoCurrentLine()
	Elephant:UpdateCurrentLogButtons()
	
	local i
	for i = Elephant.tempConf.currentline-Elephant.defaultConf.scrollmaxlines, Elephant.tempConf.currentline do
		if Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i] then
			Elephant.gui.scrollingMessageFrame:AddMessage(Elephant:GetLiteralMessage(Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i]))
		end
	end
	
	--[[ Updating message catchers button ]]
	for _,v in pairs(Elephant.db.profile.events) do
		if v.channels and v.channels[Elephant.dbpc.char.currentlogindex] then
			if not Elephant.gui.elephantButtonCatchOptions:IsEnabled() then
				Elephant.gui.elephantButtonCatchOptions:Enable()
			end
			return
		end
	end
	
	if Elephant.gui.elephantButtonCatchOptions:IsEnabled() then
		Elephant.gui.elephantButtonCatchOptions:Disable()
	end
end

function Elephant:SetTitleInfoCurrentLine()
	Elephant.gui.titleInfoCurrentLine:SetText(Elephant.tempConf.currentline .. " / " .. #Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs)
end

function Elephant:SetTitleInfoMaxLog()
	if Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.combat then
		Elephant.gui.titleInfoMaxLog:SetText( format(L['maxlog'], Elephant.db.profile.maxcombatlog) )
	else
		Elephant.gui.titleInfoMaxLog:SetText( format(L['maxlog'], Elephant.db.profile.maxlog) )
	end
end

function Elephant:ShowCopyWindow()
	Elephant.gui.mainFrame:Hide()
	
	Elephant:FillCopyWindowNormalText()
	
	Elephant.gui.copyFrame:Show()
end

function Elephant:FillCopyWindowNormalText()
	Elephant.gui.copyFrameScrollFrameEditBox:SetText("")
	Elephant:SetObjectColorWithCurrentLogColor(Elephant.gui.copyFrameScrollFrameEditBox)
	local i
	for i = Elephant.tempConf.currentline-Elephant.defaultConf.copywindowmaxlines, Elephant.tempConf.currentline do
		if Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i] then
			Elephant.gui.copyFrameScrollFrameEditBox:Insert(Elephant:GetLiteralMessage(Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i]) .. "\n")
		end
	end
	
	Elephant.gui.elephantCopyFrameButtonBBCode:SetScript("OnClick", function() Elephant:FillCopyWindowBBText() end)
end

function Elephant:FillCopyWindowBBText()
	Elephant.gui.copyFrameScrollFrameEditBox:SetText("|r")
	Elephant.gui.copyFrameScrollFrameEditBox:SetTextColor(0.75, 0.75, 0.75, 1.0)
	local i, msg
	for i = Elephant.tempConf.currentline-Elephant.defaultConf.copywindowmaxlines, Elephant.tempConf.currentline do
		if Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i] then
			msg = Elephant:GetLiteralMessage(Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs[i])
			msg = string.gsub(msg, "\|c%x%x(%x%x%x%x%x%x)\|Hitem:(%d-):.-|h(.-)|h|r", "[url=" .. L['itemLinkSite'] .. "%2][color=#%1]%3[/color][/url]")
			msg = string.gsub(msg, "\|c%x%x(%x%x%x%x%x%x)(.-)|r", "[color=#%1]%2[/color]")
			Elephant.gui.copyFrameScrollFrameEditBox:Insert(msg .. "\n")
		end
	end
	
	Elephant.gui.elephantCopyFrameButtonBBCode:SetScript("OnClick", function() Elephant:FillCopyWindowNormalText() end)
end

function Elephant:UpdateCurrentLogButtons()
	if Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].enabled then
		Elephant.gui.buttonEnable:GetFontString():SetText(L['Disable'])
	else
		Elephant.gui.buttonEnable:GetFontString():SetText(L['Enable'])
	end
	if #Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs > 0 then
		Elephant.gui.buttonCopy:Enable()
	else
		Elephant.gui.buttonCopy:Disable()
	end
	if L['generalchats'][Elephant.dbpc.char.currentlogindex] or (type(Elephant.dbpc.char.currentlogindex) == "number") then
		Elephant.gui.buttonDelete:Disable()
	elseif GetChannelName(Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].name) > 0 then
		Elephant.gui.buttonDelete:Disable()
	else
		Elephant.gui.buttonDelete:Enable()
	end
end

function Elephant:ForceCurrentLogDeleteButtonStatus(isEnabled)
	if isEnabled then
		Elephant.gui.buttonDelete:Enable()
	else
		Elephant.gui.buttonDelete:Disable()
	end
end

function Elephant:Scroll(n)
	local oldIndex = Elephant.tempConf.currentline
	
	Elephant.tempConf.currentline = Elephant.tempConf.currentline+n
	if Elephant.tempConf.currentline < 1 then
		Elephant.tempConf.currentline = 1
	end
	if Elephant.tempConf.currentline > #Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs then
		Elephant.tempConf.currentline = #Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].logs
	end
	
	-- Prevent too much processing
	if oldIndex ~= Elephant.tempConf.currentline then
		Elephant:ShowCurrentLog()
	end
end

function Elephant:SetObjectColorWithCurrentLogColor(obj)
	local typeInfo
	
	if Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.whisper then
		typeInfo = "WHISPER"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.raid then
		typeInfo = "RAID"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.party then
		typeInfo = "PARTY"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.say then
		typeInfo = "SAY"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.yell then
		typeInfo = "YELL"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.officer then
		typeInfo = "OFFICER"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.guild then
		typeInfo = "GUILD"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.system then
		typeInfo = "SYSTEM"
	elseif Elephant.dbpc.char.currentlogindex == Elephant.defaultConf.defaultindexes.loot then
		typeInfo = "LOOT"
	else
		typeInfo = "CHANNEL"
		
		local channelId, channelName
		local i
		-- Max: 20 channels
		for i=1,20 do
			channelId,channelName = GetChannelName(i)
			
			if
				channelName ~= nil and
				string.lower(channelName) == string.lower(Elephant.dbpc.char.logs[Elephant.dbpc.char.currentlogindex].name)
			then
				typeInfo = "CHANNEL" .. channelId
				break
			end
		end
	end
	
	obj:SetTextColor(ChatTypeInfo[typeInfo].r, ChatTypeInfo[typeInfo].g, ChatTypeInfo[typeInfo].b, ChatTypeInfo[typeInfo].a)
end

local function PlaceTooltip(frame, msg, position)
	if not (type(msg) == "table") then
		return
	end
	
	GameTooltip:SetOwner(frame, position)
	for i,v in ipairs(msg) do
		if i == 1 then
			GameTooltip:SetText("|c00FFFFFF" .. v .. "|r")
		else
			GameTooltip:AddLine(v)
		end
	end
	GameTooltip:Show()
end

function Elephant:SetTooltip(frame, msg)
	if msg == nil then
		-- TODO: Remove this
		Elephant:Print("Calling nil message on frame:")
		Elephant:Print(frame)
	end
	PlaceTooltip(frame, msg, "ANCHOR_RIGHT")
end

function Elephant:Toggle()
	if Elephant.gui.mainFrame:IsVisible() then
		Elephant.gui.mainFrame:Hide()
	else
		Elephant.gui.mainFrame:Show()
	end
end

function Elephant:ResetPosition()
	Elephant.gui.mainFrame:ClearAllPoints()
	Elephant.gui.mainFrame:SetPoint("TOP", Elephant.defaultConf.position.x, Elephant.defaultConf.position.y)
end

function Elephant:UnsetTooltip()
	if GameTooltip:IsVisible() then
		GameTooltip:Hide()
	end
end

function Elephant:ChatLogEnable(enabledStatus)
	if not Elephant.db.profile.activate_log then
		return
	end
	
	if not (LoggingChat() == enabledStatus) then
		LoggingChat(enabledStatus)
	end
end

function Elephant:CombatLogEnable(enabledStatus)
	if not Elephant.db.profile.activate_log then
		return
	end
	
	if not (LoggingCombat() == enabledStatus) then
		LoggingCombat(enabledStatus)
	end
end

function Elephant:CreateButton()
	Elephant.gui.menuButton = CreateFrame("Button", "ElephantFrameMenuButton", UIParent)
	Elephant.gui.menuButton:SetMovable(true)
	Elephant.gui.menuButton:SetWidth(32)
	Elephant.gui.menuButton:SetHeight(34)
	Elephant.gui.menuButton:SetPoint("BOTTOM", ChatFrameMenuButton, "TOP")
	Elephant.gui.menuButton:SetNormalTexture("Interface/Buttons/UI-SpellbookIcon-NextPage-Up")
	Elephant.gui.menuButton:SetPushedTexture("Interface/Buttons/UI-SpellbookIcon-NextPage-Down")
	Elephant.gui.menuButton:SetDisabledTexture("Interface/Buttons/UI-SpellbookIcon-NextPage-Disabled")
	Elephant.gui.menuButton:SetHighlightTexture("Interface/Buttons/UI-Common-MouseHilight")
	Elephant.gui.menuButton:SetScript("OnEnter", function()
		Elephant:SetTooltip(Elephant.gui.menuButton, L['togglebuttontooltip'])
	end)
	Elephant.gui.menuButton:SetScript("OnLeave", function() Elephant:UnsetTooltip() end)
	Elephant.gui.menuButton:SetScript("OnClick", function() Elephant:Toggle() end)
	Elephant.gui.menuButton:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" then
			Elephant.gui.menuButton:StartMoving()
		end
		if button == "MiddleButton" then
			Elephant:ResetButtonPosition()
		end
	end)
	Elephant.gui.menuButton:SetScript("OnMouseUp", function() Elephant.gui.menuButton:StopMovingOrSizing() end)
end

function Elephant:ResetButtonPosition()
	Elephant.gui.menuButton:ClearAllPoints()
	Elephant.gui.menuButton:SetPoint("BOTTOM", ChatFrameMenuButton, "TOP")
end

function Elephant:ToggleButton()
	if not Elephant.gui.menuButton then
		Elephant:CreateButton()
		Elephant.db.profile.button = true
	else
		if Elephant.gui.menuButton:IsVisible() then
			Elephant.gui.menuButton:Hide()
			Elephant.db.profile.button = false
		else
			Elephant.gui.menuButton:Show()
			Elephant.db.profile.button = true
		end
	end
end